﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Windows.Controls;
using BuiltToRoam;
using BuiltToRoam.SocialReader;
using BuiltToRoam.SocialReader.Lists;

namespace $safeprojectname$.Pages.Main
{
    public partial class MainPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();

            
        }

        protected override void OnPageLoaded()
        {
            base.OnPageLoaded();

            
            var appid = (this.DataContext as MainPageViewModel).AdGacAppId;
            if (!appid.Equals(Guid.Empty))
            {
                AdGac.AppId = appid;

                if (Debugger.IsAttached ||
                    Microsoft.Devices.Environment.DeviceType == Microsoft.Devices.DeviceType.Emulator)
                {
                    AdGac.TestMode = true;
                }
            }
        }
        
        private void AboutMenuItem_Click(object sender, System.EventArgs e)
        {
            (this.DataContext as MainPageViewModel).DisplayAbout();
        }

        private void SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            OpenSelectedListItem(sender as ListBox);
        }


        private void OpenSelectedListItem(ListBox list)
        {
            // Grab the selected item and check to make sure that something is selected
            var item = list.SelectedItem as ISocialActivityWrapper;
            if (item != null)
            {
                // Reset the selected item so that when the user comes back to this page
                // there is nothing selected in the list (otherwise selecting the same 
                // item again won't trigger the selection changed event).
                list.SelectedIndex = -1;

                (this.DataContext as MainPageViewModel).DisplaySocialActivity(item, list.ItemsSource as IEnumerable<ISocialActivityWrapper>);

            }
        }

        private void SettingsButton_Click(object sender, System.EventArgs e)
        {
            (this.DataContext as MainPageViewModel).DisplaySettings();
        }

        private void RefreshClick(object sender, System.EventArgs e)
        {
        	(this.DataContext as MainPageViewModel).RefreshActivities();
        }

        private void PurchaseMenuItem_Click(object sender, EventArgs e)
        {
            Utilities.LaunchMarketplaceDetails();
        }
    }
}