﻿using System;
using System.Diagnostics;
using System.Windows;
using System.Windows.Controls;
using BuiltToRoam;
using BuiltToRoam.SocialReader;
using BuiltToRoam.SocialReader.Pages.Reader;
using Microsoft.Phone.Controls;

namespace $safeprojectname$.Pages.Reader
{
    public partial class ReaderPage 
    {
        // Constructor
        public ReaderPage()
        {
            InitializeComponent();
        }

        protected override void OnPageLoaded()
        {
            base.OnPageLoaded();

            AdGac.AppId = (this.DataContext as ReaderPageViewModel).AdGacAppId;

            if (Debugger.IsAttached || Microsoft.Devices.Environment.DeviceType == Microsoft.Devices.DeviceType.Emulator)
            {
                AdGac.TestMode = true;
            }
        }
        private void CommentClick(object sender, System.EventArgs e)
        {
            this.ViewModel<ReaderPageViewModelBase>().Comment();
        }
        private void ShareClick(object sender, System.EventArgs e)
        {
            this.ViewModel<ReaderPageViewModelBase>().Share();
        }

        private void TweetClick(object sender, System.EventArgs e)
        {
            this.ViewModel<ReaderPageViewModelBase>().Tweet();
        }

        private void RetweetClick(object sender, System.EventArgs e)
        {
            this.ViewModel<ReaderPageViewModelBase>().Retweet();
        }
        private void ReplyClick(object sender, System.EventArgs e)
        {
            this.ViewModel<ReaderPageViewModelBase>().Reply();
        }

        private void ReplyAllClick(object sender, System.EventArgs e)
        {
            this.ViewModel<ReaderPageViewModelBase>().ReplyAll();
        }

        private void EmailClick(object sender, EventArgs e)
        {
            this.ViewModel<ReaderPageViewModelBase>().Email();
        }

        private void OkClick(object sender, EventArgs e)
        {
            this.ViewModel<ReaderPageViewModelBase>().Post();
        }

        private void CancelClick(object sender, EventArgs e)
        {
            this.ViewModel<ReaderPageViewModelBase>().Cancel();
        }

        private void PreviousClick(object sender, EventArgs e)
        {
            this.ScrollViewer.ScrollToVerticalOffset(0);
            this.ViewModel<ReaderPageViewModelBase>().Previous();
        }

        private void NextClick(object sender, EventArgs e)
        {
            this.ScrollViewer.ScrollToVerticalOffset(0);
            this.ViewModel<ReaderPageViewModelBase>().Next();
        }

        private void TextToPostChanged(object sender, TextChangedEventArgs e)
        {
            // Force update binding when text change - otherwise the data source
            // won't be updated if the user clicks the application bar
            var binding = (sender as TextBox).GetBindingExpression(TextBox.TextProperty);
            binding.UpdateSource();
        }

        /// <summary>
        /// Handle the user clicking the Author TextBlock
        /// </summary>
        private void AuthorTap(object sender, Microsoft.Phone.Controls.GestureEventArgs e)
        {
            this.ViewModel<ReaderPageViewModelBase>().OpenAuthor(); 
        }

        private void OpenInBrowserClick(object sender, EventArgs e)
        {
            this.ViewModel<ReaderPageViewModelBase>().OpenInBrowser(); 
        }

        private void VideoTap(object sender, GestureEventArgs e)
        {
            
        }

        private void Grid_MouseLeftButtonDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
        	var source = sender as FrameworkElement;
            if (source == null) return;
            var url = source.Tag as string;
            if (string.IsNullOrEmpty(url)) return;
            Utilities.DisplayInMediaPlayer(url);
        }
    }
}